// ͂ɏ]ăLN^[ړ

#include "DxLib.h"

// ړx
#define MOVESPEED			10.0f

// DxChara.x ł̑Aj[V̔ԍ
#define ANIM_RUN			1

// DxChara.x ł̑ҋ@Aj[V̔ԍ
#define ANIM_NEUTRAL		4

// ΂ߓ͗p̊e̔{( sin( 45) )
#define VECTOR_SCALING		0.70710678118f

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	int    ModelHandle ;
	float  AnimTotalTime ;
	float  AnimNowTime ;
	int    AnimAttachIndex ;
	int    RunFlag ;
	int    MoveAnimFrameIndex ;
	VECTOR Position ;
	int    Input ;
	int    MoveFlag ;
	float  Angle ;

	// EChE[hŋN
	ChangeWindowMode( TRUE ) ;

	// cwCȕ
	if( DxLib_Init() < 0 ) return -1 ;

	// Rcf̓ǂݍ
	ModelHandle = MV1LoadModel( "DxChara.x" ) ;

	// 
	Angle = 0.0f ;

	// ĂtO|
	RunFlag = FALSE ;

	// ҋ@Aj[VA^b`
	AnimAttachIndex = MV1AttachAnim( ModelHandle, ANIM_NEUTRAL ) ;

	// ҋ@Aj[V̑Ԃ擾Ă
	AnimTotalTime = MV1GetAttachAnimTotalTime( ModelHandle, AnimAttachIndex ) ;

	// Aj[VĐԂ
	AnimNowTime = 0.0f ;
	MV1SetAttachAnimTime( ModelHandle, AnimAttachIndex, AnimNowTime ) ;

	// Aj[VňړĂt[̔ԍ
	MoveAnimFrameIndex = MV1SearchFrame( ModelHandle, "BasePoint" ) ;

	// Aj[VňړĂt[𖳌ɂ
	MV1SetFrameUserLocalMatrix( ModelHandle, MoveAnimFrameIndex, MV1GetFrameLocalMatrix( ModelHandle, MoveAnimFrameIndex ) ) ;

	// Rcf̍W
	Position = VGet( 0.0f, 0.0f, 0.0f ) ;

	// `𗠉ʂɂ
	SetDrawScreen( DX_SCREEN_BACK ) ;

	// J̈ʒuƌݒ
	SetCameraPositionAndTarget_UpVecY( VGet( 0.0f, 1200.0f, -2000.0f ), VGet( 0.0f, 400.0f, 0.0f ) );

	// J̃NbsOݒ
	SetCameraNearFar( 16.0f, 5000.0f );

	// wi̐FDFɂ
	SetBackgroundColor( 128, 128, 128 ) ;

	// C[v(L[ꂽ烋[v𔲂)
	while( ProcessMessage() == 0 )
	{
		// ʂ̃NA
		ClearDrawScreen() ;

		// Q[pbh{L[{[h̓͂擾
		Input = GetJoypadInputState( DX_INPUT_KEY_PAD1 ) ;

		// ړĂ邩ǂ̃tO|
		MoveFlag = FALSE ;

		// ͂ɏ]ăLN^[ړ
		// ( ŏɎ΂ߓ͂̔Ǎ㉺EP̂̓͂̔Ă܂ )
		if( ( Input & PAD_INPUT_LEFT ) != 0 && ( Input & PAD_INPUT_UP ) != 0 )
		{
			Angle       = 135.0f ;
			MoveFlag    = TRUE ;
			Position.x -= MOVESPEED * VECTOR_SCALING ;
			Position.z += MOVESPEED * VECTOR_SCALING ;
		}
		else
		if( ( Input & PAD_INPUT_UP ) != 0 && ( Input & PAD_INPUT_RIGHT ) != 0 )
		{
			Angle       = -135.0f ;
			MoveFlag    = TRUE ;
			Position.x += MOVESPEED * VECTOR_SCALING ;
			Position.z += MOVESPEED * VECTOR_SCALING ;
		}
		else
		if( ( Input & PAD_INPUT_RIGHT ) != 0 && ( Input & PAD_INPUT_DOWN ) != 0 )
		{
			Angle       = -45.0f ;
			MoveFlag    = TRUE ;
			Position.x += MOVESPEED * VECTOR_SCALING ;
			Position.z -= MOVESPEED * VECTOR_SCALING ;
		}
		else
		if( ( Input & PAD_INPUT_DOWN ) != 0 && ( Input & PAD_INPUT_LEFT ) != 0 )
		{
			Angle       = 45.0f ;
			MoveFlag    = TRUE ;
			Position.x -= MOVESPEED * VECTOR_SCALING ;
			Position.z -= MOVESPEED * VECTOR_SCALING ;
		}
		else
		if( ( Input & PAD_INPUT_LEFT ) != 0 )
		{
			Angle       = 90.0f ;
			MoveFlag    = TRUE ;
			Position.x -= MOVESPEED ;
		}
		else
		if( ( Input & PAD_INPUT_RIGHT ) != 0 )
		{
			Angle       = -90.0f ;
			MoveFlag    = TRUE ;
			Position.x += MOVESPEED ;
		}
		else
		if( ( Input & PAD_INPUT_DOWN ) != 0 )
		{
			Angle       = 0.0f ;
			MoveFlag    = TRUE ;
			Position.z -= MOVESPEED ;
		}
		else
		if( ( Input & PAD_INPUT_UP ) != 0 )
		{
			Angle       = 180.0f ;
			MoveFlag    = TRUE ;
			Position.z += MOVESPEED ;
		}

		// ܂łƏԂωꍇ̓Aj[VύX
		if( RunFlag != MoveFlag )
		{
			// Ă邩ǂ̃tOۑ
			RunFlag = MoveFlag ;

			// ܂ŃA^b`ĂAj[Vf^b`
			MV1DetachAnim( ModelHandle, AnimAttachIndex ) ;

			// VAj[VA^b`
			if( RunFlag )
			{
				AnimAttachIndex = MV1AttachAnim( ModelHandle, ANIM_RUN ) ;
			}
			else
			{
				AnimAttachIndex = MV1AttachAnim( ModelHandle, ANIM_NEUTRAL ) ;
			}

			// Aj[V̑Ԃ擾Ă
			AnimTotalTime = MV1GetAttachAnimTotalTime( ModelHandle, AnimAttachIndex ) ;

			// Aj[VĐԂ
			AnimNowTime = 0.0f ;
		}
		else
		{
			// Aj[VĐԂi߂
			AnimNowTime += 200.0f ;

			// Aj[VĐԂAj[V̑ԂzĂ烋[v
			if( AnimNowTime >= AnimTotalTime )
			{
				// VAj[VĐԂ́AAj[VĐԂAj[VԂ
				AnimNowTime -= AnimTotalTime ;
			}
		}

		// VAj[VĐԂZbg
		MV1SetAttachAnimTime( ModelHandle, AnimAttachIndex, AnimNowTime ) ;

		// VZbg
		MV1SetRotationXYZ( ModelHandle, VGet( 0.0f, Angle / 180.0f * DX_PI_F, 0.0f ) ) ;

		// RcfɐVWZbg
		MV1SetPosition( ModelHandle, Position ) ;

		// Rcf̕`
		MV1DrawModel( ModelHandle ) ;

		// ʂ̓e\ʂɔf
		ScreenFlip() ;
	}

	// cwCǔn
	DxLib_End() ;

	// \tg̏I
	return 0 ;
}
